From 0ca052bb26f1f8bec51bc0c5a0c61647183871e2 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Oct 11 2017 11:09:42 +0000
Subject: [PATCH 976/1001] Fix moving widgets when there are disabled ones


---

diff --git a/hubs/tests/utils/test_views.py b/hubs/tests/utils/test_views.py
index 13d9c1c..50af636 100644
--- a/hubs/tests/utils/test_views.py
+++ b/hubs/tests/utils/test_views.py
@@ -108,3 +108,30 @@ class ViewUtilsTest(APPTest):
         check_move(
             "contact", 5,
             ["about", "bugzilla", "dummy", "badges", "contact"])
+
+    def test_move_widget_disabled(self):
+        # Make sure moving works even if there are disabled widgets
+        hub = Hub(name="testing")
+        self.session.add(hub)
+
+        def _make_widget(name, index):
+            widget = Widget(
+                hub=hub, plugin=name,
+                left=True, index=index, _config="{}")
+            self.session.add(widget)
+            return widget
+
+        nonexistant_widget = _make_widget("nonexistant", 0)
+        about_widget = _make_widget("about", 1)
+        badges_widget = _make_widget("badges", 1)
+        # The UI does not display the disabled widget, so moving the second
+        # widget to the third slot is actually a move from index 0 to 1.
+        move_widget(about_widget, 1)
+        self.session.flush()
+        self.session.refresh(hub)
+        self.session.refresh(nonexistant_widget)
+        self.assertEqual(nonexistant_widget.index, 0)  # no change
+        self.session.refresh(about_widget)
+        self.session.refresh(badges_widget)
+        self.assertEqual(about_widget.index, 1)
+        self.assertEqual(badges_widget.index, 0)
diff --git a/hubs/utils/views.py b/hubs/utils/views.py
index 2445387..2508dad 100644
--- a/hubs/utils/views.py
+++ b/hubs/utils/views.py
@@ -154,7 +154,10 @@ def configure_widget_instance(widget_instance, widget_config):
 
 def reorder_widgets(hub, is_left):
     """Reset widget instances indicies for a hub and a column."""
-    all_widgets = [w for w in hub.widgets if w.left == is_left]
+    all_widgets = [
+        w for w in hub.widgets
+        if w.left == is_left and w.enabled
+        ]
     for index, widget in enumerate(all_widgets):
         widget.index = index
 
@@ -163,7 +166,7 @@ def move_widget(widget_instance, new_index):
     """Move a widget instance to a new index in the same column."""
     all_widgets = [
         w for w in widget_instance.hub.widgets
-        if w.left == widget_instance.left
+        if w.left == widget_instance.left and w.enabled
         ]
     old_index = [w.idx for w in all_widgets].index(widget_instance.idx)
     # Move the widget in the list

